
{========================================================================================)
  Component TDhCheckFolder Version 1.2, Sept. 2003
{========================================================================================)


    Description:
    ============
    Displays all System-Folder and Drives ( Network too ). All folder with State-Icons
    and you can check them and save the checks to disk.


    Author:
    =======
    (c) Hubert Indetzki 1998, 2003
    Dammer Hof 12
    49088 Osnabrueck
    Germany


    V 1.0:
     - now running under Delphi 4.0
     - changed Component-Name from SystemFolderList to DhCheckFolder
     - added Desktop-Icon
     - added property ChangeFolder
     - removed property StateBoxes
     - changed procedure CreateStates               r1
     - added property CheckBoxes                    r1
     - added CheckDriveList                         r1
     - procedure KeyDown changed (better Ergonomy)  r1
     - changed CheckDriveList to public             r1
    V 1.1:
     - Network supported
     - added procedure SaveCheckedFolder
     - added public procedure SetInitialDir
     - added RefreshNode                            r1
     - whole Network supported                      r1
     - Desktop-Folder supported                     r2
     - Now compatible with Windows 98 ME            r3
     - removed RefreshNode                          r3
    V 1.2:
     - one click for expand folder now supported
     - bug: not all drives are shown fixed
     - now works with Windows XP
     - bug delphi7 in ComponentState fixed

{========================================================================================}


unit DhCheckFolder12;

interface


{$INCLUDE DhCheckComps.inc}
{$IFDEF D6_OR_HIGHER}
  {$WARN SYMBOL_PLATFORM OFF}
  {$WARN UNIT_PLATFORM OFF}
{$ENDIF}
{$IFDEF D7_OR_HIGHER}
  {$WARN UNSAFE_CODE OFF}
  {$WARN UNSAFE_TYPE OFF}
{$ENDIF}


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,  ComCtrls, ShellApi,
  ShlObj, ComObj, Commctrl, ActiveX, StdCtrls, ExtCtrls, Menus, DhCheckFiles12,
  BasicUnit;


const
  NOT_CHECKED = $01;
  CHECKED = $02;
  GRAY_CHECKED = $03;
  NEUTRAL = $04;
  crPencil = $05;
  TIMER_INTERVALL = 100;
  JOKER = '\*.*';
const
  DEFAULT_INITIAL_DIR = 'C:\';
  WINDOWS_DRIVE = 'C:\';
  DESKTOP_PATH = 'C:\Windows\Desktop';
  DOUBLE_SLASH = '\\';
const
  SFGAO_CANCOPY           = DROPEFFECT_COPY; { Objects can be copied }
  SFGAO_CANMOVE           = DROPEFFECT_MOVE; { Objects can be moved }
  SFGAO_CANLINK           = DROPEFFECT_LINK; { Objects can be linked }
  SFGAO_CANRENAME         = $00000010;       { Objects can be renamed }
  SFGAO_CANDELETE         = $00000020;       { Objects can be deleted }
  SFGAO_HASPROPSHEET      = $00000040;       { Objects have property sheets }
  SFGAO_DROPTARGET        = $00000100;       { Objects are drop target }
  SFGAO_CAPABILITYMASK    = $00000177;
  SFGAO_LINK              = $00010000;       { Shortcut (link) }
  SFGAO_SHARE             = $00020000;       { shared }
  SFGAO_READONLY          = $00040000;       { read-only }
  SFGAO_GHOSTED           = $00080000;       { ghosted icon }
  SFGAO_HIDDEN            = $00080000;       { hidden object }
  SFGAO_DISPLAYATTRMASK   = $000F0000;
  SFGAO_FILESYSANCESTOR   = $10000000;       { It contains file system folder }
  SFGAO_FOLDER            = $20000000;       { It's a folder. }
  SFGAO_FILESYSTEM        = $40000000;       { is a file system thing (file/folder/root) }
  SFGAO_HASSUBFOLDER      = $80000000;       { Expandable in the map pane }
  SFGAO_CONTENTSMASK      = $80000000;
  SFGAO_VALIDATE          = $01000000;       { invalidate cached information }
  SFGAO_REMOVABLE         = $02000000;       { is this removeable media? }
  SFGAO_COMPRESSED        = $04000000;       { Object is compressed (use alt color) }
  SFGAO_BROWSABLE         = $08000000;       { is in-place browsable }
  SFGAO_NONENUMERATED     = $00100000;       { is a non-enumerated object }
  SFGAO_NEWCONTENT        = $00200000;       { should show bold in explorer tree }

  // Peter Stotz says : All-Attributes is passed to an IShellFolder when creating or
  // updating a node. The remarked attributes cause on some systems an access to the
  // drives A and B.
  ALL_ATRIBUTES =  SFGAO_HASPROPSHEET or SFGAO_DROPTARGET or SFGAO_CAPABILITYMASK or
                   SFGAO_LINK or SFGAO_SHARE or SFGAO_GHOSTED or SFGAO_FILESYSANCESTOR or
                   SFGAO_FOLDER or SFGAO_FILESYSTEM or SFGAO_HASSUBFOLDER or
                   SFGAO_CONTENTSMASK or SFGAO_REMOVABLE or SFGAO_COMPRESSED;
                   {SFGAO_CANRENAME or SFGAO_CANDELETE or SFGAO_READONLY or SFGAO_VALIDATE
                    or SFGAO_DISPLAYATTRMASK}

  DESKTOP_ATTR        = $F0000050; // Desktop-Icon (items[0])
  WORKSTATION_ATTR    = $B0000154; // Workstation-Icon (items[1])
  NETWORK_MAIN_ATTR   = $B0000144; // Network-Root-Main-Icon
  NETWORK_SUB_ATTR    = $B0000044; // whole network + workgroup + client, server
  FOLDER_WORK_STATION = $F0000144; // "Gemeinsame Dokumente" und "Dateien von Admin"
  RECYCLED_ATTR       = $60080177; // Folder "Recycled"
  SYS_VOL_INFO        = $7088017F; // Folder "System Volume Information"
  DESKTOP_FOLDER : array[1..3] of integer = ( CSIDL_PERSONAL, CSIDL_DRIVES, CSIDL_NETWORK );

  { Netzwerkumgebung                  NETWORK_MAIN_ICON
     Gesamtes Netzwerk
      Microsoft Windows-Netzwerk      MS_WIN_NET_WORK
       MsHeimnetz
        master
        slave
      Microsoft Terminal Dienste
      WebClient Network }



type
  TOnChangeFolderEvent = procedure ( path : string ) of object;
  TOnCheckFolderReady = procedure ( count : integer ) of object;
  TDhCheckFolder = class(TCustomTreeView)

  private
   FNodesReadReady : boolean;
   FhtOnLabel : boolean;
   FHtOnState : boolean;
   FHtOnIcon : boolean;
   FHtOnButton : boolean;
   FDesktopFolder : array[1..3] of string;
   FFolderList : TStringList;
   FCheckedFolderCount : integer;
   FCheckedFolderList : tStringList;
   FFirstRead : boolean;
   FHasChanged : boolean;
   FCheckFiles : TDhCheckFiles;
   FCurNode : tTreeNode;
   FNetworkMainAttr : ULONG;
   FNetworkSubAttr : ULONG;
   FDesktopIcon : integer;
   FSortFolder : boolean;
   FInitialDir : string;
   FCheckBoxes : boolean;
   FSomeFolderChecked : boolean;
   FOnChangeFolder : tOnChangeFolderEvent;
   FCurDir : string;
   FPidlPath : PItemIdList;
   FCanExpand : boolean;
   FCanCollapse : boolean;
   FItemsCount : integer;
   FCheckFolderReady : tOnCheckFolderReady;
   FStateImageList : tImageList;
   FFullPidlPathList : tList;
  protected
   function EnumerateSubFolder ( node : TTreeNode; level : integer ) : integer;
   function CountCheckedFolder : integer;
   procedure SetCheckFiles ( CF : TDhCheckFiles );
   procedure MakeDriveVisible ( list : tStringList );
   procedure CheckFolder ( node : tTreeNode );
   procedure CreateWnd; override;
   procedure DestroyWnd; override;
   procedure Loaded; override;
   procedure SetCheckBoxes ( value : boolean );
   function GetStateChecked : integer;
   procedure SetStateChecked ( state : integer );
   function GetCheckedFolderList : tStringList;
   procedure AddCheckedFolderToList ( folder : string );
   procedure InitialisizeComponent;
   function AddSubNodesWithFolder ( path : string; AllFolder : boolean ) : boolean;
   function AddSubNodesWithNode ( node : tTreeNode;  AllFolder : boolean ) : boolean;
   function ExploreNetwork : boolean;
   procedure SwitchStateIndex ( node : tTreeNode; attr : ULONG );
   function EnumerateFolder (  ShellFolder: IShellFolder; AllFolder : boolean; node : tTreeNode ) : boolean;
   procedure ClearAllItems;
   function ProofStates ( node : tTreeNode ) : boolean;
   procedure MouseMove( Shift: TShiftState; X, Y: Integer); override;
   procedure click; override;
   procedure DblClick; override;                                                             // ##
   procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
   procedure Changing ( Sender: TObject; Node: TTreeNode; var AllowChange: Boolean );
   procedure Change ( Node: TTreeNode ); override;
   procedure KeyDown (  var Key: Word; Shift: TShiftState ); override;
   procedure KeyUp (  var Key: Word; Shift: TShiftState ); override;
   function CanExpand ( node: tTreeNode ) : boolean; override;
   function CanCollapse ( node: tTreeNode ) : boolean; override;

   //procedure Expanding ( node: TTreeNode; AllowExpansion: Boolean ); override;
   //procedure Collapsing( node: TTreeNode; AllowCollapse: Boolean);  override
   function CheckSibling ( node : tTreeNode ) : boolean;
   procedure CheckSubFolder ( node : tTreeNode );
   procedure CreateImages;
   procedure CreateStates;
  public
   constructor create (AOwner: TComponent); override;
   destructor destroy; override;
   function SubFolderChecked ( node : tTreeNode ) : boolean;
   procedure ReCreatePathInTree ( path : string; node : tTreeNode; visible : boolean );
   function FindNodeInTreeView ( StartNode : tTreeNode; path : string ): integer;
   function CurNode : tTreeNode;
   procedure CheckParentFolder ( node : tTreeNode );
   property PidlPath : PItemIdList read fPidlPath;
   property Directory : string read fCurDir;
   procedure ClearAllChecks;
   procedure SetInitialDir ( path : string );
   procedure SaveChecksToDisk ( FileName : string );
   procedure LoadChecksFromDisk ( FileName : string );
  published
   // link to the ListView-Component
   property LinkToCheckFiles : TDhCheckFiles read FCheckFiles write SetCheckFiles;
   property CheckBoxes : boolean read FCheckBoxes write SetCheckBoxes
    default true;
   property OnChangeFolder : tOnChangeFolderEvent read fOnChangeFolder
                                                          write fOnChangeFolder;
   property OnCheckFolderReady : tOnCheckFolderReady read fCheckFolderReady
                                             write fCheckFolderReady;
   property NodeChecked : integer read GetStateChecked write SetStateChecked
    default NOT_CHECKED;

   property CheckedFolderCount : integer read fCheckedFolderCount;
   property CheckedFolderList : TStringList read GetCheckedFolderList
                                            write fCheckedFolderList;
   property AutoExpand;
   property ReadOnly;
   property Align;
   property Enabled;
   property Font;
   property HideSelection;
   property Items;
   property ParentColor;
   property PopupMenu;
   property Selected;
   property TabOrder;
   property TabStop default true;
  end;


{ *************************** SUBROUTINES ************************************* }
function CountCharsInString ( s : string; c : char ) : integer;
function GetPidlFileAttribut ( path : string ) : boolean;
function CombinePidls ( id1, id2 : PItemIDList ) : PItemIDList;

function GetPidlSize ( pidl: PItemIdList ) : integer;
function GetDirectory ( ShellFolder : IShellFolder; idList : PItemIDList; Flags : DWORD ) :
                                                                                   string;
function GetSelectedIcon ( list : PItemIdList ) : integer;
function GetNormalIcon ( list : PItemIdList ) : integer;


procedure Register;

var
  ShellMalloc : iMalloc;
  fRootShellFolder : iShellFolder;


implementation

{$R DhCheckFolder12.res}




function DefaultTreeViewSort(Node1, Node2: TTreeNode; lParam: integer): integer; stdcall;   //##
var
  drive1, drive2 : string;
begin
  drive1 := ExtractFileDrive ( GetDirectory ( FRootShellFolder, Node1.data, SHGDN_FORPARSING ));
  drive2 := ExtractFileDrive ( GetDirectory ( FRootShellFolder, Node2.data, SHGDN_FORPARSING ));

  if pos ( ':', node1.text ) > 0 then
   result := lstrcmp ( PChar(drive1), PChar(drive2) )
    else
     result := 1;
end;


function CountCharsInString ( s : string; c : char ) : integer;
var
  i : integer;
begin
  result := 0;
  i := pos ( c, s );
  while i > 0 do
   begin
    inc(result);
    s := copy ( s, i+1, pred(length(s)) );
    i := pos ( c, s );
   end;
end;


function IsItADrive ( path : string ) : boolean;
var
  info : tShFileInfo;
  HexAttr : string;
begin
  result := false;
  FillChar ( info.szTypeName, 80, ' ' );
  SHGetFileInfo ( PChar( path), 0, info, sizeof ( info ), SHGFI_ATTRIBUTES or//);
                                                                         SHGFI_TYPENAME );
  HexAttr := IntToHex (info.dwAttributes, 4);
  //if ( info.dwAttributes = DRIVE_ATTR ) then
  if ( info.szTypeName = 'Hallo' ) then
   result := true;
end;


function GetPidlFileAttribut ( path : string ) : boolean;
var
  info : tShFileInfo;
begin
  result := false;
  SHGetFileInfo ( PChar( path), 0, info, sizeof (info), SHGFI_ATTRIBUTES );
  if ( info.dwAttributes and SFGAO_FILESYSTEM ) > 0 then
   result := true;
end;


procedure SplitPathToList ( path : string; list : tStringList );
var
  index : integer;
  dir : string;
  temp : string;
begin
  path := AddSlash ( path );
  temp := path;
  index := pos ( '\', temp  );
  while index > 0 do
   begin
    dir := copy ( path, 1, pred(index) );
    if length(dir) > 1 then list.add ( dir );
    temp[index] := ' ';
    index := pos ( '\', temp  );
   end;
end;


function GetPidlSize ( pidl: PItemIdList ): integer;
begin
  result := 0;
  if pidl <> nil then
   begin
    inc ( result, SizeOf(pidl^.mkid.cb) );
    while pidl^.mkid.cb <> 0 do
     begin
      inc ( result, pidl^.mkid.cb );
      inc ( longint(pidl), pidl^.mkid.cb );
     end;
   end;
end;


function CreatePIDL ( size: UINT): PItemIDList;
begin
  result := ShellMalloc.Alloc(size);
  if result <> nil then
   FillChar ( result^, size, #0 );
end;


function CombinePIDLs ( id1, id2: PItemIDList ): PItemIDList;
var
  s1, s2 : UINT;
begin
  if (id1 <> nil) then
   s1 := GetPIDLSize(id1) - SizeOf(id1.mkid.cb)
   else
    s1 := 0;
  s2 := GetPIDLSize(id2);

  result := CreatePIDL(s1 + s2);
  if result <> nil then
   begin
    if (id1 <> nil) then
     move ( id1^, result^, s1 );
    move ( id2^, PChar(result)[s1], s2 );
   end;
end;


function GetDirectory ( ShellFolder : iShellFolder;
                                 IdList : pItemIdList; flags : DWORD ) : string;
var
  str : tStrRet;
  name : string;
begin
  name := '';
  if ShellFolder.GetDisplayNameOf ( IdList, flags, str ) = NOERROR then
  begin
    case str.uType of
     STRRET_WSTR :
      name := WideCharToString(str.pOleStr);
     STRRET_OFFSET :
      name := PChar(ULONG(IdList) + str.uOffset);
     STRRET_CSTR :
      name := str.cStr;
    end;
  end;
  result := RemoveSlash ( name );
end;


function GetFolderAttribut ( list : pItemIdList ) : integer;
var
  info : tShFileInfo;
  HexAttr : string;
begin
  FillChar ( info.szDisplayName, MAX_PATH, ' ' );
  info.dwAttributes := $00000000;
  ShGetFileInfo ( PChar(list), 0, info, SizeOf(tShFileInfo), SHGFI_PIDL or
                                                   SHGFI_DISPLAYNAME or SHGFI_ATTRIBUTES );
  HexAttr := IntToHex ( info.dwAttributes, 4 );
  result := info.dwAttributes;
end;


function GetNormalIcon ( list : pItemIdList ) : integer;
var
  info : tShFileInfo;
begin
  ShGetFileInfo ( PChar(list), 0, info, SizeOf(tShFileInfo), SHGFI_PIDL or
                                             SHGFI_SYSICONINDEX or SHGFI_SMALLICON );
    result := info.iIcon;
end;


function GetSelectedIcon ( list : pItemIdList ) : integer;
var
  info : tShFileInfo;
begin
  ShGetFileInfo ( PChar(list), 0, info, SizeOf(tShFileInfo), SHGFI_PIDL or
                            SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_OPENICON );
  result := info.iIcon;
end;


constructor TDhCheckFolder.create(AOwner: TComponent);
begin
  inherited create(AOwner);
  width := 220;
  height := 140;
  CreateStates;
  CreateImages;
  fFirstRead := true;
  fHasChanged := false;
  fCheckBoxes := true;
  fCanExpand := true;
  fCanCollapse:= true;
  fCurNode := nil;
  fDesktopIcon := -1;
  fNetworkMainAttr := 0;
  fNetworkSubAttr := 0;
  fSortFolder := true;
  fInitialDir := DEFAULT_INITIAL_DIR;
  fCurDir := DEFAULT_INITIAL_DIR;
  OnChanging := Changing;
  fFullPidlPathList := tList.create;
  fCheckedFolderList := tStringList.create;
  FFolderList := tStringList.create;
  fCheckedFolderList.sorted := true;
  fCheckedFolderList.duplicates := dupIgnore;
end;


destructor TDhCheckFolder.destroy;
Begin
  ClearAllItems;
  fCheckedFolderList.free;
  FFolderList.free;
  fFullPidlPathList.free;
  images.free;
  if assigned ( StateImages ) then
   fStateImageList.free;
  inherited;
End;


procedure TDhCheckFolder.CreateWnd;
var
  index : integer;
begin
  inherited CreateWnd;

  font.size := 8;
  font.name := 'arial';

  if not ( csLoading in ComponentState ) then
   begin
    InitialisizeComponent;
    // select InitialDir
    index := FindNodeInTreeview ( items[0], fInitialDir );
    if index > 0 then items[index].selected := true;
   end;
end;


procedure TDhCheckFolder.DestroyWnd;
begin
  inherited DestroyWnd;
end;


procedure TDhCheckFolder.Loaded;
var
  index : integer;
begin
  inherited Loaded;
  InitialisizeComponent;
  // select InitialDir
  index := FindNodeInTreeview ( items[0], fInitialDir );
  if index > 0 then items[index].selected := true;
end;


procedure TDhCheckFolder.SetCheckFiles ( CF : TDhCheckFiles );
begin
  if assigned ( FCheckFiles ) then
   FCheckFiles.LinkToCheckFolder := nil;

  FCheckFiles := CF;

  if assigned ( FCheckFiles ) then
   FCheckFiles.LinkToCheckFolder := self;
end;


procedure TDhCheckFolder.SetCheckBoxes ( value : boolean );
begin
  fCheckBoxes := value;
  if value then
   StateImages := fStateImageList
    else
     StateImages := nil;
end;


function TDhCheckFolder.GetStateChecked : integer;
var
  node : tTreeNode;
begin
  //fCanExpand := false;
  result := NOT_CHECKED;
  node := FCurNode;

  if node <> nil then
   begin
    result := node.StateIndex;
   end;
end;


procedure TDhCheckFolder.SetStateChecked ( state : integer);
var
  node : tTreeNode;
begin
  //fCanExpand := false;
  node := selected;
  if ( node <> nil ) and ( Node.AbsoluteIndex <> 0 )then
   Node.StateIndex := state;
end;


function TDhCheckFolder.CurNode : tTreeNode;
var
  node : tTreeNode;
begin
  node := selected;
  result := node;
end;


procedure TDhCheckFolder.SetInitialDir ( path : string );
var
  SplitPathList : tStringList;
  index : integer;
  i : integer;
  SplitPath : string;
Begin
  fInitialDir := path;
  if items.count = 0 then
   exit;
  screen.cursor := crHourGlass;
  if pos ( DOUBLE_SLASH, path ) > 0 then
   begin
    if not ExploreNetwork then
     begin
      screen.cursor := crDefault;
      exit;
     end;
   end;

  SplitPathList := tStringList.create;
  //if DirectoryExists ( path ) then
   begin
    SplitPathToList ( path, SplitPathList );
    // if there is a Network-Drive choosed
    for i:=0 to SplitPathList.count-2 do
     begin
      SplitPath := SplitPathList[i];
      //if pos ( 'Windows', SplitPath ) > 0 then
      // beep;
      AddSubNodesWithFolder ( SplitPath, true );
     end;
    index := FindNodeInTreeView ( items[0], path );
    if index > 0 then
     begin
      fCanExpand := true;
      items[index].selected := true;
     end;
   end;
  screen.cursor := crDefault;
  SplitPathList.free;
End; {SetInitialDir}


Procedure TDhCheckFolder.SaveChecksToDisk ( FileName : string ); //tTreeView
var
  list : tStringList;
  i : integer;
  node : tTreeNode;
  path : string;

Begin
  list := tStringList.create;
  // store checked folder
  for i:=0 to items.count-1 do
   begin
    node := items[i];
    if node.level >= 1 then
     begin
      if Node.StateIndex = CHECKED then
       begin
        if Node.GetFirstChild <> nil then
         if Node.GetFirstChild.StateIndex = CHECKED then
          continue;
        path := GetDirectory ( FRootShellFolder, node.data, SHGDN_FORPARSING );
        list.add ( path + JOKER );
       end;
     end;
   end;
  list.SaveToFile ( FileName );
  list.free;
  // Save checks in ListView
  if assigned ( FCheckFiles ) then
   FCheckFiles.SaveChecksToDisk ( FileName );
End; {SaveCheckedFolder}


procedure TDhCheckFolder.LoadChecksFromDisk ( FileName : string );
var
  i, k : integer;
  SplitPathList : tStringList;
  path : string;
  node : TTreeNode;
  index : integer;
  SplitPath : string;
  OldPath : string;
  DoBreak : boolean;
  list : tStringList;
  NetReady : boolean;
  PosJoker : integer;
Begin
  screen.cursor := crHourGlass;
  SplitPathList := tStringList.create;
  list := tStringList.create;
  ClearAllChecks;
  list.LoadFromFile ( FileName );
  // add nodes if necessary
  OldPath := '';
  DoBreak := false;
  NetReady := false;
  Application.ProcessMessages;
  items.BeginUpdate;
  for i:=0 to list.count-1 do
   begin
    if DoBreak then
     break;
    SplitPathList.clear;
    if FileExists ( list[i] ) then                // if file then get next
     continue;
    PosJoker := pos ( JOKER, list[i] );           // Joker entfernen                           //##
    if PosJoker > 0 then
     path := copy ( list[i], 1, PosJoker-1 );

    FCheckedFolderList.add ( path );
    // add network drives
    if (pos ( DOUBLE_SLASH, Path ) > 0) and not NetReady then
     if ExploreNetwork then
      NetReady := true
       else
        DoBreak := true;
    SplitPathToList ( path, SplitPathList );
    // add nodes without Sub-Nodes
    for k:=0 to SplitPathList.count-1 do
    //for k:=0 to SplitPathList.count-2 do
     begin
      SplitPath := SplitPathList[k];
      if DoBreak then
       break;
      if OldPath <> SplitPath then
       AddSubNodesWithFolder ( SplitPath, false );
      OldPath := SplitPath;
    end;
   end;
  // check nodes if necessary
  if not DoBreak then
   begin
    node := items[0];
    for i:=0 to list.count-1 do
     begin
      PosJoker := pos ( JOKER, list[i] );           // Joker entfernen                           //##
      if PosJoker > 0 then
       path := copy ( list[i], 1, PosJoker-1 );
      index := FindNodeInTreeView ( node, path );
      if index > 0 then
       CheckFolder ( items[index] );
      // if Desktop-Folder is checked
      if pos ( LowerCase(DESKTOP_PATH), LowerCase(path)) > 0 then
       begin
        node := items[index];
        index := FindNodeInTreeView ( Node.GetNext, path );
        if index > 0 then
         CheckFolder ( items[index] );
        node := items[0];
       end;
     end;
   end;
  items.EndUpdate;
  Application.ProcessMessages;
  // make drive visible
  if list.count > 0 then
   MakeDriveVisible ( list );
  screen.cursor := crDefault;
  SplitPathList.free;
  list.free;

  if DoBreak then
   begin
    MessageBeep ( MB_ICONASTERISK );
    MessageDlg ( 'There is no Network !', mtError, [mbOk], 0);
   end;
   // Load checks from ListView
  if assigned ( FCheckFiles ) then
   FCheckFiles.LoadChecksFromDisk ( FileName );
End; {LoadCheckedFolder}


procedure TDhCheckFolder.CheckFolder ( node : tTreeNode );
begin
  Node.StateIndex := CHECKED;
  CheckParentFolder ( node );
  CheckSubFolder ( node );
end;


procedure TDhCheckFolder.MakeDriveVisible ( list : tStringList );
var
  drive : string;
  node : tTreeNode;
  index : integer;
begin
  FCanExpand := true;
  drive := ExtractFileDrive ( list[0] );
  node := items[0];
  index := FindNodeInTreeView ( node, drive );
  if index > 0 then
   begin
    node := items[index];
    node.MakeVisible;
   end;
end;


Function TDhCheckFolder.GetCheckedFolderList : TStringList;
var
  node : tTreeNode;
  path : string;
  AddPath : boolean;
Begin
  // code added bug up delphi 6, in D4 it works.
  if ( csLoading in ComponentState ) or (csDesigning in ComponentState) then
   begin
    result := fCheckedFolderList;
    exit;
   end;
  fCheckedFolderList.clear;
  node := items[1];
  AddPath := true;
  while node <> nil do
   begin
    if ( Node.StateIndex = CHECKED ) then
     begin
      fPidlPath := node.data;
      path := GetDirectory ( FRootShellFolder, fPidlPath, SHGDN_FORPARSING );
      if AddPath then
       begin
        FCheckedFolderList.add ( path + JOKER );
        AddCheckedFolderToList ( path );
        AddPath := false;
       end;
      if Node.GetNext <> nil then
       begin
        Node := Node.GetNext;
        if Node.Parent.StateIndex <> CHECKED then
         AddPath := true;
       end
        else break;
     end
      else Node := Node.GetNext;
   end; // end while do ..
  result := fCheckedFolderList;
End; {TDhCheckFolder.GetCheckedFolderList}


Procedure TDhCheckFolder.AddCheckedFolderToList ( folder : string );
var
   result : integer;
   f : tSearchRec;
   SubFolder : string;
   index : integer;
Begin
  result := FindFirst ( folder + '\*.*', faAnyFile, f );
  while result = 0 do
   begin
    if ( f.name[1] <> '.' ) then
     if ( f.attr and faDirectory > 0 ) then  { if folder then.. }
      begin
       //if pos ( 'Downloaded', f.name  ) > 0 then
       // beep;
       SubFolder := f.name;
       folder := folder + '\' + SubFolder;
       if ( f.attr and faSysFile = 0 ) then
        begin
         AddCheckedFolderToList ( folder );
         FCheckedFolderList.add ( folder + JOKER  ) ;
        end;
       index := length(folder) - length(SubFolder);
       system.delete ( folder, index, length(SubFolder) + 1 );
      end;
    result := FindNext( f );
   end; { end while do.. }
  FindClose ( F );
End;


procedure TDhCheckFolder.ClearAllChecks;
var
  node : tTreeNode;
begin
  fCheckedFolderList.clear;
  node := items[0];
  while node <> nil do
   begin
    if ( Node.StateIndex > 0 ) and ( Node.StateIndex <> NEUTRAL ) then
     Node.StateIndex := NOT_CHECKED;
    node := node.GetNext;
   end;
end;


Procedure TDhCheckFolder.InitialisizeComponent;
var
  FolderName : string;
  RootId : pItemIDList;
  ShellFolder : iShellFolder;
  node : tTreeNode;
  IdList : pItemIDList;
  i : integer;

Begin
  ClearAllItems;
  ShGetDesktopFolder ( FRootShellFolder );
  // Get the Desktop-Main-Icon
  ShGetSpecialFolderLocation ( handle, CSIDL_DESKTOP, RootId );
  FolderName := GetDirectory ( FRootShellFolder, RootId, SHGDN_NORMAL );
  Node := items.AddChildObject ( nil, FolderName, RootId );
  Node.ImageIndex := GetNormalIcon ( RootId );
  fDesktopIcon := Node.ImageIndex;
  Node.SelectedIndex := GetSelectedIcon ( RootId );
  Node.StateIndex := -1;
  node.data := RootId;
  fFullPidlPathList.add ( RootId );
  // Add Workstation-Folder, Network-Folder and PersonalData-Folder
  for i:=1 to 3 do
   begin
    ShGetSpecialFolderLocation ( handle, DESKTOP_FOLDER[i], RootId );
    FolderName := GetDirectory ( FRootShellFolder, RootId, SHGDN_NORMAL );
    Node := items.AddChildObject ( node, FolderName, RootId );
    Node.HasChildren := true;
    Node.ImageIndex := GetNormalIcon ( RootId );
    FDesktopFolder[i] := node.text;
    Node.SelectedIndex := GetSelectedIcon ( RootId );
    Node.StateIndex := -1;
    if i = 1 then Node.StateIndex := NOT_CHECKED;
    node.data := RootId;
    fFullPidlPathList.add ( RootId );
    node := node.parent;
   end;
  // Add local Drives +  "Gemeinsame Dokumente" und "Dateien von Admin""
  node := items[2];
  IdList := node.data;
  FRootShellFolder.BindToObject ( IdList, nil, IID_IShellFolder, pointer(ShellFolder));
  EnumerateFolder ( ShellFolder, false, node );
  Node.CustomSort ( @DefaultTreeViewSort, 0 );

  //ExploreNetwork;
  if fInitialDir <>  DEFAULT_INITIAL_DIR then
   SetInitialDir ( fInitialDir );                                                            // ##
End; {InitialisizeComponent}


function TDhCheckFolder.AddSubNodesWithFolder ( path : string; AllFolder : boolean) : boolean;
var
  PidlPath : pItemIDList;
  ShellFolder : iShellFolder;
  node : tTreeNode;
  index : integer;
Begin
  result := false;
  node := items[0];
  // Search current path in TreeView.
  index := FindNodeInTreeView ( node, path );
  if index > 0 then
   node := items[index]
    else exit;
  if ( node.GetFirstChild = nil ) then
   if ( node.HasChildren ) then
    begin
     PidlPath := node.data;
     // Get System-Folder in TreeView.
     FRootShellFolder.BindToObject ( PidlPath, nil, IID_IShellFolder, pointer(ShellFolder));
     if EnumerateFolder ( ShellFolder, AllFolder, node ) then
      result := true;
     if fSortFolder then
      TreeView_SortChildren ( handle, node.ItemId, 0 );
      //Node.CustomSort ( @DefaultTreeViewSort, 0 );                                    // ##
    end;
End; {AddSubNodesWithFolder}


function TDhCheckFolder.CountCheckedFolder : integer;
var
  node : tTreeNode;
begin
  result := 0;
  node := items[0];
  while node <> nil do
   begin
    if Node.StateIndex = CHECKED then
     inc ( result );
    node := Node.GetNext;
   end;
end;


function CheckForGrayFolder ( folder : string ) : boolean;
const
  UnCheckAbleFolder : array[1..3] of string = ( 'Recycled', 'Temp', 'Cache' );
  CheckAbleFolder : array[1..1] of string = ( 'Driver Cache' );
var
  i, k : integer;
begin
  result := false;
  for i:=1 to 3 do                                  // make gray folder
   if pos ( LowerCase(UnCheckAbleFolder[i]), LowerCase(folder) ) > 0 then
    begin
     for k:=1 to 1 do                                 // normal folder
      if pos ( LowerCase(CheckAbleFolder[k]), LowerCase(folder) ) > 0 then
       exit;
     result := true;
     break;
    end;
end;


procedure TDhCheckFolder.SwitchStateIndex ( node : tTreeNode; attr : ULONG );            // ##
var
  NodePath : string;
begin
  NodePath := GetDirectory ( FRootShellFolder, node.data, SHGDN_FORPARSING );
  //if pos ( 'driver cache', LowerCase(NodePath) ) > 0 then
  // beep;
  // this is for the virtual folder.
  //if ( attr and SFGAO_HIDDEN > 0 )  then
  // beep;
  if ( attr and SFGAO_FILESYSTEM = 0 )  then
   begin
    Node.StateIndex := -1;
    fSortFolder := false;
   end
    //else if (( attr and SFGAO_HIDDEN ) > 0) then            // gray box   SFGAO_GHOSTED
    else if CheckForGrayFolder (NodePath) then
     Node.StateIndex := NEUTRAL
      else
       if Node.StateIndex <> NEUTRAL then     // norrmal folder
        if node.parent.StateIndex = CHECKED then
         Node.StateIndex := CHECKED
          else Node.StateIndex := NOT_CHECKED;
  fCheckedFolderCount := CountCheckedFolder;
end; {TDhCheckFolder.SwitchStateIndex}


Function TDhCheckFolder.EnumerateFolder ( ShellFolder: IShellFolder;
                            AllFolder : boolean; node : tTreeNode ) : boolean;
var
  flags : DWORD;
  EnumList : IEnumIdList;
  FQ_PIDL, PidlPath, list : PItemIdList;
  fetched : ULONG;

  FolderName: string;
  attr : ULONG;
  HexAttr : string;
  ImageIndex : integer;
  flag : boolean;

Begin
  //FFolderList.Clear;
  result := false;
  PidlPath := node.data;
  fSortFolder := true;
  flags := SHCONTF_FOLDERS or SHCONTF_INCLUDEHIDDEN;
  if ( ShellFolder.EnumObjects ( handle, flags, EnumList )) = NOERROR then
   begin
    while EnumList.Next ( 1, list, fetched ) = S_OK do
     begin
      FolderName := GetDirectory ( ShellFolder, list, SHGDN_NORMAL );
      attr := ALL_ATRIBUTES;
      ShellFolder.GetAttributesOf ( 1, list, attr );
      HexAttr := IntToHex (attr, 4);
      //if HexAttr = '0000' then           //NETWORK_MAIN_ATTR
      // beep;
      //if (pos ( 'windows-netzwerk', LowerCase(FolderName) ) > 0) then
      // beep;
      flag := false;
      // real folder + virtual folder
      if AllFolder then                                                                    // ##
       flag := true
        else if not AllFolder then                                      // only real folder
         flag := ( attr and SFGAO_FILESYSTEM > 0 ) and ( attr and SFGAO_FOLDER > 0 );

      if flag then
       begin
        FQ_PIDL := CombinePidls ( PidlPath, list );
        fFullPidlPathList.add ( FQ_PIDL );
        ImageIndex := GetNormalIcon ( FQ_PIDL );

        node := items.AddChildObject ( node, FolderName, FQ_PIDL );
        //FFolderList.add ( '"' + FolderName + '"; Attr: ' + HexAttr);
        if ( attr and SFGAO_HASSUBFOLDER > 0 ) then
         Node.HasChildren := true;
        Node.ImageIndex := ImageIndex;
        Node.SelectedIndex := GetSelectedIcon ( FQ_PIDL );
        // image with hand-icon
        if ( SFGAO_SHARE and attr ) > 0 then
         Node.OverlayIndex := 0;
        // switch State-Icon
        SwitchStateIndex ( node, attr );

        node := node.parent;
        result := true;
       end;
      ShellMalloc.free ( list );
      // filter out client + server
      {if ( ImageIndex = WHOLE_NETWORK_ICON ) and ( fCheckBoxes ) then
       begin
        beep;
        break;
       end;}
     end; // end while do ..
   end;
   //FFolderList.SaveToFile('FolderList.dat');
End; {EnumerateFolder}


procedure TDhCheckFolder.Change ( Node: TTreeNode );
begin
  if not fFirstRead then
   begin
    fHasChanged := true;
    if assigned ( FCheckFiles ) then
     FCheckFiles.ClearListView;
   end;
  fFirstRead := false;
  node := selected;
  fCurNode := node;
  fPidlPath := node.data;
  if fPidlPath <> nil then
   begin
    if Node.StateIndex >= 0 then
     fCurDir := GetDirectory ( FRootShellFolder, fPidlPath, SHGDN_FORPARSING )
      else fCurDir := node.text;
    if ( assigned(FOnChangeFolder)) then
     FOnChangeFolder ( fCurDir );
   end;
  inherited Change(node);
end;


procedure TDhCheckFolder.Click;                                                               //##
var
  state : integer;
  NodePath : string;
  flag : boolean;
Begin
  FNodesReadReady := false;
  if FCurNode <> nil then
   begin
    if FHtOnButton or FHtOnIcon or FHtOnLabel then         // node or button or lebel clicked
     begin
      NodePath := GetDirectory ( FRootShellFolder, FCurNode.data, SHGDN_FORPARSING );
      //if NodePath = 'A:' then
       // beep;
      flag := true;                          // if folder is virtual then flag
      if pos ( '\', NodePath ) > 0 then      // else only add real folder
       flag := false;;
      if FCurNode.GetFirstChild = nil then
       if AddSubNodesWithNode ( fCurNode, flag ) then   // only if nodes added expand the tree
        begin
         FNodesReadReady := true;
         Application.ProcessMessages;
         if FHtOnButton then
          FCurNode.expand(false);
        end;
     end
      else if FHtOnState then
       begin                                                               //state clicked
        NodePath := GetDirectory ( FRootShellFolder, fCurNode.data,  SHGDN_FORPARSING );
        // Check nodes and update fCheckedFolderList
        if ProofStates ( FCurNode ) then
         FCheckedFolderCount := CountCheckedFolder;
         state := GetStateChecked;
        // Only check files, if node is selected.
        if FCurNode = selected then
         if assigned ( FCheckFiles ) then                                                     //###
          FCheckFiles.CheckAllFiles ( state, false );
          //FCheckFiles.CheckAllFiles ( state, true );
       end;
    if fHasChanged then // Show files in ListView
     if assigned ( FCheckFiles ) then
      FCheckFiles.RunReadFilesThread ( FPidlPath, FCurDir, true, GetStateChecked );
   end; {if CurNode}
  Application.ProcessMessages;
  fHasChanged := false;
  inherited Click;
end; {TDhCheckFolder.Click}


procedure TDhCheckFolder.DblClick;
begin
  if FHtOnIcon or FHtOnLabel then         // node or label clicked
   begin
    if FNodesReadReady  then
     FCurNode.expand(false);
   end;
  inherited DblClick;
end;


function TDhCheckFolder.CanExpand ( node: TTreeNode ) : boolean;
begin
  result := fCanExpand;
end;


function TDhCheckFolder.CanCollapse ( node: TTreeNode ) : boolean;
begin
  result := FCanCollapse;
end;


procedure TDhCheckFolder.MouseMove ( Shift: TShiftState; X, Y: Integer );
var
  ht : THitTests;
begin
  FCanExpand := true;
  FCanCollapse := true;
  FHtOnIcon := false;
  FHtOnButton := false;
  FHtOnState := false;
  FhtOnLabel := false;
  if screen.cursor <> crHourGlass then
   begin
    fCurNode := GetNodeAt ( x, y );
    ht := GetHitTestInfoAt ( x, y  );
    if htOnStateIcon in ht then
     begin
      fCanExpand := false;
      FCanCollapse := false;
      FHtOnState := true;
      screen.cursor := crPencil;
     end
      else
       screen.cursor := crDefault;
    if htOnIcon in ht then
     FHtOnIcon := true;
    if htOnButton in ht then
     FHtOnButton := true;
    if htOnLabel in ht then
     FhtOnLabel := true;
   end;
  inherited MouseMove ( shift, x, y );
end;


procedure TDhCheckFolder.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Begin
  inherited  MouseDown ( Button, Shift, X, Y );
end; {TDhCheckFolder.MouseDown}


procedure TDhCheckFolder.KeyDown (  var Key : Word; Shift: TShiftState );
var
  node : tTreeNode;
begin
  fCanExpand := false;
  node := selected;
  // if right Cursor-Key is pressed.
  if Key = VK_RIGHT then
   AddSubNodesWithNode ( node, true );
  Application.ProcessMessages;
  fCanExpand := true;

  inherited KeyDown ( Key, Shift );
end; {KeyDown}


procedure TDhCheckFolder.Changing ( Sender: TObject; Node: TTreeNode;
                                                               var AllowChange: boolean );
begin
  if not fCanExpand
   then AllowChange := false;
end;


procedure TDhCheckFolder.KeyUp (  var Key: Word; Shift: TShiftState );
begin
  if fCanExpand then   // Show files in ListView
   if assigned ( FCheckFiles ) then
    FCheckFiles.RunReadFilesThread ( FPidlPath, FCurDir, false, GetStateChecked );
  inherited;
end;


Function TDhCheckFolder.AddSubNodesWithNode ( node : tTreeNode;  AllFolder : boolean ) : boolean;
var
  idList : pItemIDList;
  ShellFolder : iShellFolder;
  attr : DWORD;
  IsNetWork : boolean;
  //NetNode : tTreeNode;
  ChildNode : tTreeNode;
Begin
  result := false;
  IsNetWork := false;
  // Refresh Network
  attr := GetFolderAttribut ( node.data );
  if ( attr = fNetworkSubAttr ) and ( node.GetFirstChild <> nil ) then
   if ( node.GetFirstChild.StateIndex = -1 ) then
    begin
     while 1=1 do
      begin
       if ( Node.GetNext <> nil ) then
        begin
         ChildNode := Node.GetNext;
         // only refrsh, if there one sibling childs
         if ChildNode.GetNext = nil then
          begin
           IsNetWork := true;
           Node.GetNext.delete;
          end
           else break;
        end
         else break;
      end;
   end;
  if (( node.HasChildren ) and ( node.GetFirstChild = nil )) or IsNetWork then
   begin
    screen.cursor := crHourGlass;
    idList := node.data;
    FRootShellFolder.BindToObject ( idList,  nil, IID_IShellFolder,
                                                       pointer ( ShellFolder ));
    EnumerateFolder ( ShellFolder, AllFolder,  node );
    if fSortFolder then
     TreeView_SortChildren ( handle, node.ItemId, 0 ); // hTreeItem                   // ##
      //Node.CustomSort ( @DefaultTreeViewSort, 0 );
    if ( node.HasChildren ) and ( node.GetFirstChild = nil ) then
     if ( pos ( DOUBLE_SLASH, fCurDir ) > 0 ) or
      ( pos ( LowerCase(DESKTOP_PATH), LowerCase(fCurDir) ) > 0 ) then
       Node.HasChildren := false;
    screen.cursor := crDefault;
    fItemsCount := items.count;
    result := true;                 // only if nodes added to TreeView
   end;
End; {AddSubNodesWithNode}


function TDhCheckFolder.ProofStates ( node : tTreeNode ) : boolean;                           // ###
var
  rect : TRect;
  DispRect : TRect;
  ChildNode : TTreeNode;
  NodeVisible : boolean;
Begin
  rect := ClientRect;
  NodeVisible := false;
  result := false;
  if Node.StateIndex = NEUTRAL then exit;

  if ( Node.StateIndex = NOT_CHECKED ) or ( Node.StateIndex = GRAY_CHECKED ) then
   begin
    node.StateIndex := CHECKED;
    result := true;
   end
    else
     if ( node.StateIndex = CHECKED ) then Node.StateIndex := NOT_CHECKED;

  ValidateRect ( handle, @rect );
  ChildNode := Node.GetFirstchild;
  if ChildNode <> nil then
   if ChildNode.IsVisible then
    begin
     CheckParentFolder ( node );
     CheckSubFolder ( node );
     NodeVisible := true;
    end;
  if ( ChildNode = nil ) or ( not NodeVisible ) then  // check only one node
   begin
    DispRect := Node.DisplayRect ( true );
    DispRect.top := DispRect.top + 4;
    DispRect.left := DispRect.left - 34;
    DispRect.right := DispRect.left + 16;
    DispRect.Bottom := DispRect.Bottom - 4;
    InvalidateRect ( handle, @DispRect, false );
    CheckParentFolder ( node );
    CheckSubFolder ( node );
   end
    else
     begin
      ValidateRect ( handle, @rect );
      InvalidateRect ( handle, @rect, false );
     end;
End;


function TDhCheckFolder.SubFolderChecked ( node : tTreeNode ) : boolean;                       //###
var
  level : integer;
Begin
  result := false;
  level := node.level;
  node := node.GetFirstChild;
  while node <> nil do
   begin
    if ( node = nil ) or ( node.level <= level ) then
     break;
    if ( Node.StateIndex = GRAY_CHECKED ) or ( Node.StateIndex = CHECKED ) then
     begin
      result := true;
      break;
     end;
    Node := Node.GetNext;
   end;
End; {TDhCheckFolder.SubFolderChecked}


procedure TDhCheckFolder.CheckSubFolder ( node : tTreeNode );
var
  state : integer;
  level : integer;
Begin
  level := node.level;
  state := node.StateIndex;
  node := node.GetFirstChild;
  while node <> nil do
   begin
    if ( node = nil ) or ( node.level <= level ) then
     break;
    if Node.StateIndex <> NEUTRAL then
     begin
      Node.StateIndex := state;
      // Check files in ListView.
      if node = selected then
       if assigned ( FCheckFiles ) then
        FCheckFiles.CheckAllFiles ( state, false );
     end;
    Node := Node.GetNext;
   end;

  fCheckedFolderCount := CountCheckedFolder;
End; {TDhCheckFolder.CheckSubFolder}


procedure TDhCheckFolder.CheckParentFolder ( node : tTreeNode );
var
  AllFolderChecked : boolean;
  NodePath : string;
Begin
  while node.parent.level >= 1 do
   begin
    NodePath := GetDirectory ( FRootShellFolder, Node.Parent.data,  SHGDN_FORPARSING );
    if Node.Parent.StateIndex < 0 then
     begin
      node := node.parent;
      continue;
     end;
    AllFolderChecked := CheckSibling ( node.parent );

    if AllFolderChecked then
     begin
      Node.Parent.StateIndex := CHECKED;
     end
      else
      if ( not AllFolderChecked ) and ( not FSomeFolderChecked ) then
       Node.Parent.StateIndex := NOT_CHECKED
        else
        if FSomeFolderChecked then
         Node.Parent.StateIndex := GRAY_CHECKED;
    node := node.parent;
   end;
  fCheckedFolderCount := CountCheckedFolder;
End; {TDhCheckFolder.CheckParentFolder}


function TDhCheckFolder.CheckSibling ( node : tTreeNode ) : boolean;
var
  folder : string;

Begin
  result := true; // if all folder are checked
  FSomeFolderChecked := false;

  Node := Node.GetFirstChild;
  while node <> nil do
   begin
    folder := node.text;
    if ( Node.StateIndex = CHECKED ) then
     FSomeFolderChecked := true;
    if ( Node.StateIndex = GRAY_CHECKED ) then
     begin
      FSomeFolderChecked := true;
      result := false;
      break;
     end
      else
       if Node.StateIndex = NOT_CHECKED then
        result := false;
    Node := Node.GetNextSibling;
   end;
End;


function TDhCheckFolder.FindNodeInTreeView ( StartNode : tTreeNode; path : string ) : integer;
var
  PidlPath : pItemIdList;
  NodePath : string;
  node : tTreeNode;
  IsFolder : boolean;
Begin
  result := -1;
  node := StartNode;
  IsFolder := false;
  if ( pos ( ':', path ) <= 0 ) and ( pos ( DOUBLE_SLASH, path ) = 0 ) then
   IsFolder := true
    else
     path := RemoveSlash ( path );

  while node <> nil do
   begin
    //if pos ( 'Server', node.text ) > 0 then
    //if node.text = 'Server' then
    // beep;
    PidlPath := node.data;
    if PidlPath <> nil then
     NodePath := GetDirectory ( FRootShellFolder, PidlPath,  SHGDN_FORPARSING );
     if IsFolder then
      NodePath := node.text;
     if CompareText ( LowerCase(path), LowerCase(NodePath) ) = 0 then
      begin
       result := node.AbsoluteIndex;
       break;
      end;
    Node := Node.GetNext
   end;
End;


procedure TDhCheckFolder.ReCreatePathInTree ( path : string; node : tTreeNode;
                                                                      visible : boolean );
var
  SplitPathList : tStringList;
  i : integer;
  SplitPath : string;
  index : integer;
begin
  SplitPathList := tStringList.create;
  if pos ( '\', path ) > 0 then
   begin
    SplitPathToList ( path, SplitPathList );
    for i:=0 to SplitPathList.count-1 do
     begin
      SplitPath := SplitPathList[i];
      AddSubNodesWithFolder ( SplitPath, true );
     end;
   end;
  // find the path before deletion and make it visible
  if visible then
   begin
    index := FindNodeInTreeView ( items[0], path );
    if index > 0 then
     begin
      // node := items[index];
      items[index].MakeVisible;
     end;
   end;
  SplitPathList.free;
end;


function TDhCheckFolder.EnumerateSubFolder ( node : TTreeNode; level : integer ) : integer;
var
  IdList : pItemIDList;
  ShellFolder : iShellFolder;
  i, k  : integer;
  StartNode : TTreeNode;
  StartLevel : integer;
begin
  result := -1;
  i:=0;
  StartNode := node;
  StartLevel := node.level;
  if node.text = 'hallo' then
    beep;
  while node <> nil do  // walk through whole tree
   begin
    IdList := node.data;
    FRootShellFolder.BindToObject ( IdList, nil, IID_IShellFolder, pointer(ShellFolder));

    EnumerateFolder ( ShellFolder, true, node );
    inc(i);
    if Node.GetNext <> nil then
     if (node.level <= level) then
      begin
       if node.level = level then
        begin
         if Node.GetNextSibling <> nil then          // goto next Folder in Child-Area
          Node := Node.GetNextSibling
           else if Node.GetNextSibling = nil then    // if last Folder in child-area is reached (level)
            begin
             for k:=1 to Node.Level-StartLevel-1 do  // then go back in tree
              Node := Node.parent;
             if Node.GetNextSibling <> nil then      // till folder of parent-area is reached
              Node := Node.GetNextSibling
               else break;
            end;
        end
         else Node := Node.GetNext;
      end;

   //if pos ( 'rescueme', LowerCase(node.text) ) > 0 then
   // beep;
   if node.level <= StartNode.level then
    begin
     result := i;
     break;
    end;
   end;
end; {EnumerateSubFolder}


function TDhCheckFolder.ExploreNetwork : boolean;                                            // ##
const
  level = 4;
var
  node : tTreeNode;
  index : integer;
Begin
  result := false;
  index := FindNodeInTreeView ( items[0], FDesktopFolder[3] );   // find folder "Netzwerkumgebung"
  node := items[index];
  if node = nil then
   exit;
  Application.ProcessMessages;
  EnumerateSubFolder ( node, level );                // build network-folder (master, slave)
  Application.ProcessMessages;
  index := FindNodeInTreeView ( items[0], FDesktopFolder[3] );
  node := items[index];
  node.expand ( true );
  result := true;
End; { ExploreNetwork }


procedure TDhCheckFolder.CreateStates;
var
  i : integer;
  bitmap : tBitmap;
  ResName : string;
begin
  bitmap := tBitmap.create;
  fStateImageList := tImageList.create(self);
  for i := 1 to 5 do
   begin
    ResName := 'TV_STATUS' + IntToStr(i);
    Bitmap.LoadFromResourceName ( hInstance, ResName );
    FStateImageList.add ( bitmap, nil );
   end;
  bitmap.free;
  StateImages := fStateImageList;
end;


procedure TDhCheckFolder.CreateImages;
var
 SysIL : uint;
 sfi : tshFileInfo;

begin
  Images := tImageList.create( self );
  SysIL := ShGetFileInfo ( '', 0, sfi, SizeOf(sfi), SHGFI_SYSICONINDEX or
                                                        SHGFI_SMALLICON );
  if SysIL <> 0 then
   begin
    Images.Handle := SysIL;
    Images.ShareImages := true;
   end;
  //screen.cursors[crPencil] := LoadCursor ( HInstance, 'PENCIL_TV1' );
  screen.cursors[crPencil] := LoadCursor ( HInstance, 'TV_PENCIL' );
end;


procedure TDhCheckFolder.ClearAllItems;
var
  i : integer;
begin
  for i := 0 to fFullPidlPathList.count-1 do
   begin
    if fFullPidlPathList[i] <> nil then
     begin
      ShellMalloc.free ( fFullPidlPathList[i] );
      fFullPidlPathList[i] := nil;
     end;
   end;
  items.clear;
end;


Procedure Register;
Begin
  RegisterComponents ( 'DhComps', [TDhCheckFolder] );
End;


initialization
  ShGetMalloc ( ShellMalloc );



END.


